<< problem 60 - Prime pair sets | Cubic permutations - problem 62 >> |

# Problem 61: Cyclical figurate numbers

(see projecteuler.net/problem=61)

Triangle, square, pentagonal, hexagonal, heptagonal, and octagonal numbers are all figurate (polygonal) numbers and are generated by the following formulae:

TriangleP_{3,n}=n(n+1)/21, 3, 6, 10, 15, ...

SquareP_{4,n}=n^21, 4, 9, 16, 25, ...

PentagonalP_{5,n}=n(3n-1)/21, 5, 12, 22, 35, ...

HexagonalP_{6,n}=n(2n-1)1, 6, 15, 28, 45, ...

HeptagonalP_{7,n}=n(5n-3)/21, 7, 18, 34, 55, ...

OctagonalP_{8,n}=n(3n-2)1, 8, 21, 40, 65, ...

The ordered set of three 4-digit numbers: 8128, 2882, 8281, has three interesting properties.

The set is cyclic, in that the last two digits of each number is the first two digits of the next number (including the last number with the first).

Each polygonal type: triangle (P_{3,127}=8128), square (P_{4,91}=8281), and pentagonal (P_{5,44}=2882), is represented by a different number in the set.

This is the only set of 4-digit numbers with this property.

Find the sum of the only ordered set of six cyclic 4-digit numbers for which each polygonal type: triangle, square, pentagonal, hexagonal, heptagonal, and octagonal,

is represented by a different number in the set.

# My Algorithm

The container `all`

contains a simple bitmask for each number `x`

:

- if the 3rd bit is set, then `x`

is a triangle number

- if the 4th bit is set, then `x`

is a square number

- if the 5th bit is set, then `x`

is a pentagonal number

- if the 6th bit is set, then `x`

is a hexagonal number

- if the 7th bit is set, then `x`

is a heptagonal number

- if the 8th bit is set, then `x`

is a octagonal number

Function `deeper`

recursively builds a `sequence`

of number, where each number's highest two digits are equal to its predecessor's lowest two digits.

Even more, all numbers represent differetn categories (triangle, square, pentagonal, ...).

Some numbers belong to multiple categories. In such a case, all combinations have to be tried.

A number must not occur twice in a sequence. And finally, the last number's lowest two digits have to match the first number's highest two digits, too.

# My code

… was written in C++11 and can be compiled with G++, Clang++, Visual C++. You can download it, too.

#include <set>
#include <vector>
#include <iostream>
// all sums of valid sequences

std::set<unsigned int> results;
// 4 digits => all numbers must be below 10^4 = 10000

const unsigned int Limit = 10000;
// all number sets per number as a bitmask

std::vector<unsigned int> all(Limit, 0);
// bit mask of all categories (e.g. 1<<3 for triangle numbers, 1<<4 for square numbers, ...)

unsigned int finalMask = 0;
// add a category to a number

void add(unsigned int x, unsigned int category)
{
// reject if not exactly 4 digits
if (x < 1000 || x >= 10000)
return;
// set one bit
auto bit = 1 << category;
// adjust its bitmask
all[x] |= bit & finalMask;
}
void deeper(std::vector<unsigned int>& sequence, unsigned int mask = 0)
{
// all four digit-numbers
unsigned int from = 1000;
unsigned int to = 10000;
if (!sequence.empty())
{
// we only have to look at those numbers where the highest two digits match
// the previous numbers lowest two digits
auto lowerTwoDigits = sequence.back() % 100;
from = lowerTwoDigits * 100;
to = from + 100;
}
// try all relevant numbers
for (auto next = from; next < to; next++)
{
auto categories = all[next];
// not a member of any relevant set ?
if (categories == 0)
continue;
// must not use the same number twice
bool isUnique = true;
for (auto x : sequence)
if (x == next)
{
isUnique = false;
break;
}
if (!isUnique)
continue;
// extract all categories it belongs to
for (auto j = 3; j <= 8; j++)
{
auto thisCategory = 1 << j;
// not a member of that category ?
if ((categories & thisCategory) == 0)
continue;
// must be a new category we haven't seen yet in the current sequence
if ((mask & thisCategory) != 0)
continue;
// we have all categories ?
auto nextMask = mask | thisCategory;
if (nextMask == finalMask)
{
// must compare against first number, too
auto first = sequence.front();
auto lowerTwoDigits = next % 100;
auto upperTwoDigits = first / 100;
if (lowerTwoDigits == upperTwoDigits)
{
// we found a result, store its sum
auto sum = next;
for (auto x : sequence)
sum += x;
results.insert(sum);
}
}
else
{
// go deeper
sequence.push_back(next);
deeper(sequence, nextMask);
sequence.pop_back();
}
}
}
}
int main()
{
// only some sets are relevant to current problem
unsigned int numSets;
std::cin >> numSets;
for (unsigned int i = 0; i < numSets; i++)
{
unsigned int x;
std::cin >> x;
finalMask |= 1 << x;
}
// build sets
unsigned int n = 1;
while (true)
{
auto triangle = n * (n + 1) / 2;
// triangle numbers grow the slowest, once we have all of those then we are done
if (triangle >= 10000)
break;
// add a triangle number
add(triangle, 3);
// add a square number
auto square = n * n;
add(square, 4);
// add a pentagonal number
auto pentagon = n * (3 * n - 1) / 2;
add(pentagon, 5);
// add a hexagonal number
auto hexagon = n * (2 * n - 1);
add(hexagon, 6);
// add a heptagonal number
auto heptagon = n * (5 * n - 3) / 2;
add(heptagon, 7);
// add an octagonal number
auto octagon = n * (3 * n - 2);
add(octagon, 8);
n++;
}
// start search with an empty sequence
std::vector<unsigned int> sequence;
deeper(sequence);
// print all results in ascending order
for (auto x : results)
std::cout << x << std::endl;
return 0;
}

This solution contains 26 empty lines, 32 comments and 3 preprocessor commands.

# Interactive test

You can submit your own input to my program and it will be instantly processed at my server:

This is equivalent to`echo "3 3 4 5" | ./61`

Output:

*(this interactive test is still under development, computations will be aborted after one second)*

# Benchmark

The correct solution to the original Project Euler problem was found in less than 0.01 seconds on a Intel® Core™ i7-2600K CPU @ 3.40GHz.

(compiled for x86_64 / Linux, GCC flags: `-O3 -march=native -fno-exceptions -fno-rtti -std=c++11 -DORIGINAL`

)

See here for a comparison of all solutions.

**Note:** interactive tests run on a weaker (=slower) computer. Some interactive tests are compiled without `-DORIGINAL`

.

# Changelog

March 6, 2017 submitted solution

April 28, 2017 added comments

# Hackerrank

see https://www.hackerrank.com/contests/projecteuler/challenges/euler061

My code solves **14** out of **14** test cases (score: **100%**)

# Difficulty

Project Euler ranks this problem at **20%** (out of 100%).

Hackerrank describes this problem as **easy**.

*Note:*

Hackerrank has strict execution time limits (typically 2 seconds for C++ code) and often a much wider input range than the original problem.

In my opinion, Hackerrank's modified problems are usually a lot harder to solve. As a rule thumb: brute-force is rarely an option.

# Links

projecteuler.net/thread=61 - **the** best forum on the subject (*note:* you have to submit the correct solution first)

Code in various languages:

Python: www.mathblog.dk/project-euler-61-numbers-cyclic-property/ (written by Kristian Edlund)

Java: github.com/nayuki/Project-Euler-solutions/blob/master/java/p061.java (written by Nayuki)

Go: github.com/frrad/project-euler/blob/master/golang/Problem061.go (written by Frederick Robinson)

Scala: github.com/samskivert/euler-scala/blob/master/Euler061.scala (written by Michael Bayne)

# Heatmap

green problems solve the original Project Euler problem and have a perfect score of 100% at Hackerrank, too.

yellow problems score less than 100% at Hackerrank (but still solve the original problem).

gray problems are already solved but I haven't published my solution yet.

blue problems are solved and there wasn't a Hackerrank version of it at the time I solved it or I didn't care about it because it differed too much.

red problems are solved but exceed the time limit of one minute or the memory limit of 256 MByte.

*Please click on a problem's number to open my solution to that problem:*

1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12 | 13 | 14 | 15 | 16 | 17 | 18 | 19 | 20 | 21 | 22 | 23 | 24 | 25 |

26 | 27 | 28 | 29 | 30 | 31 | 32 | 33 | 34 | 35 | 36 | 37 | 38 | 39 | 40 | 41 | 42 | 43 | 44 | 45 | 46 | 47 | 48 | 49 | 50 |

51 | 52 | 53 | 54 | 55 | 56 | 57 | 58 | 59 | 60 | 61 | 62 | 63 | 64 | 65 | 66 | 67 | 68 | 69 | 70 | 71 | 72 | 73 | 74 | 75 |

76 | 77 | 78 | 79 | 80 | 81 | 82 | 83 | 84 | 85 | 86 | 87 | 88 | 89 | 90 | 91 | 92 | 93 | 94 | 95 | 96 | 97 | 98 | 99 | 100 |

101 | 102 | 103 | 104 | 105 | 106 | 107 | 108 | 109 | 110 | 111 | 112 | 113 | 114 | 115 | 116 | 117 | 118 | 119 | 120 | 121 | 122 | 123 | 124 | 125 |

126 | 127 | 128 | 129 | 130 | 131 | 132 | 133 | 134 | 135 | 136 | 137 | 138 | 139 | 140 | 141 | 142 | 143 | 144 | 145 | 146 | 147 | 148 | 149 | 150 |

151 | 152 | 153 | 154 | 155 | 156 | 157 | 158 | 159 | 160 | 161 | 162 | 163 | 164 | 165 | 166 | 167 | 168 | 169 | 170 | 171 | 172 | 173 | 174 | 175 |

176 | 177 | 178 | 179 | 180 | 181 | 182 | 183 | 184 | 185 | 186 | 187 | 188 | 189 | 190 | 191 | 192 | 193 | 194 | 195 | 196 | 197 | 198 | 199 | 200 |

201 | 202 | 203 | 204 | 205 | 206 | 207 | 208 | 209 | 210 | 211 | 212 | 213 | 214 | 215 | 216 | 217 | 218 | 219 | 220 | 221 | 222 | 223 | 224 | 225 |

226 | 227 | 228 | 229 | 230 | 231 | 232 | 233 | 234 | 235 | 236 | 237 | 238 | 239 | 240 | 241 | 242 | 243 | 244 | 245 | 246 | 247 | 248 | 249 | 250 |

251 | 252 | 253 | 254 | 255 | 256 | 257 | 258 | 259 | 260 | 261 | 262 | 263 | 264 | 265 | 266 | 267 | 268 | 269 | 270 | 271 | 272 | 273 | 274 | 275 |

276 | 277 | 278 | 279 | 280 | 281 | 282 | 283 | 284 | 285 | 286 | 287 | 288 | 289 | 290 | 291 | 292 | 293 | 294 | 295 | 296 | 297 | 298 | 299 | 300 |

301 | 302 | 303 | 304 | 305 | 306 | 307 | 308 | 309 | 310 | 311 | 312 | 313 | 314 | 315 | 316 | 317 | 318 | 319 | 320 | 321 | 322 | 323 | 324 | 325 |

326 | 327 | 328 | 329 | 330 | 331 | 332 | 333 | 334 | 335 | 336 | 337 | 338 | 339 | 340 | 341 | 342 | 343 | 344 | 345 | 346 | 347 | 348 | 349 | 350 |

351 | 352 | 353 | 354 | 355 | 356 | 357 | 358 | 359 | 360 | 361 | 362 | 363 | 364 | 365 | 366 | 367 | 368 | 369 | 370 | 371 | 372 | 373 | 374 | 375 |

376 | 377 | 378 | 379 | 380 | 381 | 382 | 383 | 384 | 385 | 386 | 387 | 388 | 389 | 390 | 391 | 392 | 393 | 394 | 395 | 396 | 397 | 398 | 399 | 400 |

401 | 402 | 403 | 404 | 405 | 406 | 407 | 408 | 409 | 410 | 411 | 412 | 413 | 414 | 415 | 416 | 417 | 418 | 419 | 420 | 421 | 422 | 423 | 424 | 425 |

426 | 427 | 428 | 429 | 430 | 431 | 432 | 433 | 434 | 435 | 436 | 437 | 438 | 439 | 440 | 441 | 442 | 443 | 444 | 445 | 446 | 447 | 448 | 449 | 450 |

451 | 452 | 453 | 454 | 455 | 456 | 457 | 458 | 459 | 460 | 461 | 462 | 463 | 464 | 465 | 466 | 467 | 468 | 469 | 470 | 471 | 472 | 473 | 474 | 475 |

476 | 477 | 478 | 479 | 480 | 481 | 482 | 483 | 484 | 485 | 486 | 487 | 488 | 489 | 490 | 491 | 492 | 493 | 494 | 495 | 496 | 497 | 498 | 499 | 500 |

501 | 502 | 503 | 504 | 505 | 506 | 507 | 508 | 509 | 510 | 511 | 512 | 513 | 514 | 515 | 516 | 517 | 518 | 519 | 520 | 521 | 522 | 523 | 524 | 525 |

526 | 527 | 528 | 529 | 530 | 531 | 532 | 533 | 534 | 535 | 536 | 537 | 538 | 539 | 540 | 541 | 542 | 543 | 544 | 545 | 546 | 547 | 548 | 549 | 550 |

I scored 12,983 points (out of 15100 possible points, top rank was 17 out of ≈60000 in August 2017) at Hackerrank's Project Euler+.

Look at my progress and performance pages to get more details.

My username at Project Euler is

**stephanbrumme**while it's stbrumme at Hackerrank.

# Copyright

I hope you enjoy my code and learn something - or give me feedback how I can improve my solutions.

All of my solutions can be used for any purpose and I am in no way liable for any damages caused.

You can even remove my name and claim it's yours. But then you shall burn in hell.

The problems and most of the problems' images were created by Project Euler. Thanks for all their endless effort.

<< problem 60 - Prime pair sets | Cubic permutations - problem 62 >> |